Package com.saxonica.xqj.pull

## Class PullFromIterator

- java.lang.Object
- - com.saxonica.xqj.pull.PullFromIterator

- All Implemented Interfaces:
    `PullProvider`, `UnfailingPullProvider`

      public class PullFromIterator
      extends java.lang.Object
      implements UnfailingPullProvider

  This class delivers any XPath sequence through the pull interface. Atomic values in the sequence are supplied unchanged, as are top-level text, comment, attribute, namespace, and processing-instruction nodes. Elements and documents appearing in the input sequence are supplied as a sequence of events that walks recursively down the subtree rooted at that node. The input is supplied in the form of a SequenceIterator.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.pull.PullProvider

      `PullProvider.Event`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PullFromIterator​(SequenceIterator base)` | Create a PullProvider that wraps a supplied SequenceIterator

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the event reader.
    `PullProvider.Event` | `current()` | Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd().
    `AtomicValue` | `getAtomicValue()` | Get an atomic value.
    `AttributeMap` | `getAttributes()` | Get the attributes associated with the current element.
    `NamespaceBinding[]` | `getNamespaceDeclarations()` | Get the namespace declarations associated with the current element.
    `NodeName` | `getNodeName()` | Get the NodeName identifying the name of the current node.
    `PipelineConfiguration` | `getPipelineConfiguration()` | Get configuration information.
    `SchemaType` | `getSchemaType()` | Get the type annotation of the current attribute or element node, or atomic value.
    `Location` | `getSourceLocator()` | Get the location of the current event.
    `java.lang.CharSequence` | `getStringValue()` | Get the string value of the current element, text node, processing-instruction, or top-level attribute or namespace node, or atomic value.
    `java.util.List<UnparsedEntity>` | `getUnparsedEntities()` | Get a list of unparsed entities.
    `PullProvider.Event` | `next()` | Get the next event
    `void` | `setPipelineConfiguration​(PipelineConfiguration pipe)` | Set configuration information.
    `PullProvider.Event` | `skipToMatchingEnd()` | Skip the current subtree.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PullFromIterator

          public PullFromIterator​(SequenceIterator base)

      Create a PullProvider that wraps a supplied SequenceIterator
      Parameters:
        `base` - the sequence iterator to be wrapped

  - ### Method Detail

    - #### setPipelineConfiguration

          public void setPipelineConfiguration​(PipelineConfiguration pipe)

      Set configuration information. This must only be called before any events have been read.
      Specified by:
        `setPipelineConfiguration` in interface `PullProvider`
      Parameters:
        `pipe` - the pipeline configuration

    - #### getPipelineConfiguration

          public PipelineConfiguration getPipelineConfiguration()

      Get configuration information.
      Specified by:
        `getPipelineConfiguration` in interface `PullProvider`
      Returns:
        the pipeline configuration

    - #### next

          public PullProvider.Event next()
                                  throws XPathException

      Get the next event
      Specified by:
        `next` in interface `PullProvider`
      Specified by:
        `next` in interface `UnfailingPullProvider`
      Returns:
        an event code indicating the type of event. The code `PullProvider.Event.END_OF_INPUT` is returned at the end of the sequence.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### current

          public PullProvider.Event current()

      Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd(). This method does not change the position of the PullProvider.
      Specified by:
        `current` in interface `PullProvider`
      Specified by:
        `current` in interface `UnfailingPullProvider`
      Returns:
        the current event

    - #### getAttributes

          public AttributeMap getAttributes()

      Get the attributes associated with the current element. This method must be called only after a START_ELEMENT event has been notified. The contents of the returned AttributeCollection are guaranteed to remain unchanged until the next START_ELEMENT event, but may be modified thereafter. The object should not be modified by the client.

      Attributes may be read before or after reading the namespaces of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

      Specified by:
        `getAttributes` in interface `PullProvider`
      Specified by:
        `getAttributes` in interface `UnfailingPullProvider`
      Returns:
        an AttributeCollection representing the attributes of the element that has just been notified.

    - #### getNamespaceDeclarations

          public NamespaceBinding[] getNamespaceDeclarations()

      Get the namespace declarations associated with the current element. This method must be called only after a START_ELEMENT event has been notified. In the case of a top-level START_ELEMENT event (that is, an element that either has no parent node, or whose parent is not included in the sequence being read), the NamespaceDeclarations object returned will contain a namespace declaration for each namespace that is in-scope for this element node. In the case of a non-top-level element, the NamespaceDeclarations will contain a set of namespace declarations and undeclarations, representing the differences between this element and its parent.

      It is permissible for this method to return namespace declarations that are redundant.

      The NamespaceDeclarations object is guaranteed to remain unchanged until the next START_ELEMENT event, but may then be overwritten. The object should not be modified by the client.

      Namespaces may be read before or after reading the attributes of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

      Specified by:
        `getNamespaceDeclarations` in interface `PullProvider`
      Specified by:
        `getNamespaceDeclarations` in interface `UnfailingPullProvider`
      Returns:
        the namespace declarations associated with the current START_ELEMENT event.

    - #### skipToMatchingEnd

          public PullProvider.Event skipToMatchingEnd()

      Skip the current subtree. This method may be called only immediately after a START_DOCUMENT or START_ELEMENT event. This call returns the matching END_DOCUMENT or END_ELEMENT event; the next call on next() will return the event following the END_DOCUMENT or END_ELEMENT.
      Specified by:
        `skipToMatchingEnd` in interface `PullProvider`
      Specified by:
        `skipToMatchingEnd` in interface `UnfailingPullProvider`
      Returns:
        the matching END_DOCUMENT or END_ELEMENT event

    - #### close

          public void close()

      Close the event reader. This indicates that no further events are required. It is not necessary to close an event reader after `PullProvider.Event.END_OF_INPUT` has been reported, but it is recommended to close it if reading terminates prematurely. Once an event reader has been closed, the effect of further calls on next() is undefined.
      Specified by:
        `close` in interface `PullProvider`
      Specified by:
        `close` in interface `UnfailingPullProvider`

    - #### getNodeName

          public NodeName getNodeName()

      Get the NodeName identifying the name of the current node. This method can be used after the `PullProvider.Event.START_ELEMENT`, `PullProvider.Event.PROCESSING_INSTRUCTION`, `PullProvider.Event.ATTRIBUTE`, or `PullProvider.Event.NAMESPACE` events. With some PullProvider implementations, it can also be used after `PullProvider.Event.END_ELEMENT`, but this is not guaranteed: a client who requires the information at that point (for example, to do serialization) should insert an `ElementNameTracker` into the pipeline. If called at other times, the result is undefined and may result in an IllegalStateException. If called when the current node is an unnamed namespace node (a node representing the default namespace) the returned value is null.
      Specified by:
        `getNodeName` in interface `PullProvider`
      Specified by:
        `getNodeName` in interface `UnfailingPullProvider`
      Returns:
        the NodeName. The NodeName can be used to obtain the prefix, local name, and namespace URI.

    - #### getStringValue

          public java.lang.CharSequence getStringValue()
                                                throws XPathException

      Get the string value of the current element, text node, processing-instruction, or top-level attribute or namespace node, or atomic value.

      In other situations the result is undefined and may result in an IllegalStateException.

      If the most recent event was a `PullProvider.Event.START_ELEMENT`, this method causes the content of the element to be read. The current event on completion of this method will be the corresponding `PullProvider.Event.END_ELEMENT`. The next call of next() will return the event following the END_ELEMENT event.

      Specified by:
        `getStringValue` in interface `PullProvider`
      Specified by:
        `getStringValue` in interface `UnfailingPullProvider`
      Returns:
        the String Value of the node in question, defined according to the rules in the XPath data model.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getAtomicValue

          public AtomicValue getAtomicValue()

      Get an atomic value. This call may be used only when the last event reported was ATOMIC_VALUE. This indicates that the PullProvider is reading a sequence that contains a free-standing atomic value; it is never used when reading the content of a node.
      Specified by:
        `getAtomicValue` in interface `PullProvider`
      Specified by:
        `getAtomicValue` in interface `UnfailingPullProvider`
      Returns:
        the atomic value

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of the current attribute or element node, or atomic value. The result of this method is undefined unless the most recent event was START_ELEMENT, ATTRIBUTE, or ATOMIC_VALUE.
      Specified by:
        `getSchemaType` in interface `PullProvider`
      Specified by:
        `getSchemaType` in interface `UnfailingPullProvider`
      Returns:
        the type annotation.

    - #### getSourceLocator

          public Location getSourceLocator()

      Get the location of the current event. For an event stream representing a real document, the location information should identify the location in the lexical XML source. For a constructed document, it should identify the location in the query or stylesheet that caused the node to be created. A value of null can be returned if no location information is available.
      Specified by:
        `getSourceLocator` in interface `PullProvider`
      Specified by:
        `getSourceLocator` in interface `UnfailingPullProvider`
      Returns:
        the SourceLocator giving the location of the current event, or null if no location information is available

    - #### getUnparsedEntities

          public java.util.List<UnparsedEntity> getUnparsedEntities()

      Get a list of unparsed entities.
      Specified by:
        `getUnparsedEntities` in interface `PullProvider`
      Specified by:
        `getUnparsedEntities` in interface `UnfailingPullProvider`
      Returns:
        a list of unparsed entities, or null if the information is not available, or an empty list if there are no unparsed entities.